--define global vars and defaults (saved between sessions)
local Enabled = true
local AddonVersion = GetAddOnMetadata("KObjectivesHide", "Version")

local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("KObjectivesHide: " .. tostring(msg))
end

function KObjectivesHideFrame_OnEvent(self,event,...)
	if event == "PLAYER_REGEN_ENABLED" and WatchFrame.collapsed then
		--WatchFrame:Show()
		WatchFrame_CollapseExpandButton_OnClick()
	elseif event == "PLAYER_REGEN_DISABLED" and not WatchFrame.collapsed then
		--WatchFrame:Hide()
		WatchFrame_CollapseExpandButton_OnClick()
	end
end

function KObjectivesHide_Command(Msg,Editbox)
	if Msg then Msg=strlower(Msg); end
	if Msg == "help" then
		print("v"..AddonVersion)
		print("Use /KOH | /OH [on/off/show/hide].")
		print("On/off to enable or disable automatic hiding.")
		print("Show/hide to manually show or hide the objectives list.")
		print("Examnple: /koh on")
		if Enabled then
			print("Objectives Hide is currently enabled.")
		else
			print("Objectives Hide is currently disabled.")
		end
	elseif Msg == "on" then
		Enabled = true
		print("Objectives Hide is now on.")
	elseif Msg == "off" then
		Enabled = false
		print("Objectives Hide is now off.")
	elseif Msg == "show" then
		WatchFrame:Show()
	elseif Msg == "hide" then
		WatchFrame:Hide()
	else
		KObjectivesHide_Command("help")
	end
end

--Create an anonymous blank frame
local KObjectivesHideFrame = CreateFrame("Frame")
KObjectivesHideFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
KObjectivesHideFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
KObjectivesHideFrame:SetScript("OnEvent", KObjectivesHideFrame_OnEvent)

--setup slash command feature
SlashCmdList["KObjectivesHide"]=KObjectivesHide_Command
SLASH_KObjectivesHide1, SLASH_KObjectivesHide2="/KOH","/OH"
KObjectivesHide_Command("help")
